<?php
	include("data/includes/benc.php");
	if (!function_exists("sha1")) @include_once("data/includes/sha1lib.php");

	function connect($server, $user, $pw, $db) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_pconnect("host=$server user=$user password=$pw port=5432 dbname=$db");
				if ( pg_last_error($res) ) {
					echo "An error occured while connecting to the database (CONNECT)<br />";
					echo "pgSQL-error: ". pg_last_error($res) ."<br />";
					echo "handle: ". $res ."<br />";
					echo "<br />";
				}
				break;
			case "MySQL":
	            $res = @mysql_pconnect($server,$user,$pw);
				if ( mysql_error() ) {
					echo "An error occured while connecting to the database (CONNECT)<br />";
					echo "mySQL-error: ". mysql_error() ."<br />";
					echo "handle: ". $res ."<br />";
					echo "<br />";
				}
	            @mysql_select_db($db);
				if ( mysql_error() ) {
					echo "An error occured while selecting the database (SELECT_DB)<br />";
					echo "mySQL-error: ". mysql_error() ."<br />";
					echo "handle: ". $res ."<br />";
					echo "<br />";
				}
				break;
		}
		return $res;
	}

	function query($handle, $query, $err=true) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_query($handle, "$query");
				if ( pg_last_error($handle) ) {
					if ( $err ) {
						echo "An error occured while queriing the database (QUERY)<br />";
						echo "pgSQL-error: ". pg_last_error($handle) ."<br />";
						echo "handle: ". $handle ."<br />";
						echo "query: ". $query ."<br />";
						echo "<br />";
					}
					$res = false;
				}
				break;
			case "MySQL":
				$res = @mysql_query("$query");
				if ( mysql_error() ) {
					if ( $err ) {
						echo "An error occured while queriing the database (QUERY)<br />";
						echo "mySQL-error: ". mysql_error() ."<br />";
						echo "handle: ". $handle ."<br />";
						echo "query: ". $query ."<br />";
						echo "<br />";
					}
					$res = false;
				}
				break;
		}
		return $res;
	}
	
	function fetch_object($handler) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_fetch_object($handler);
				if ( pg_last_error() ) {
					echo "An error occured while fetching an object (FETCH_OBJ)<br />";
					echo "pgSQL-error: ". pg_last_error() ."<br />";
					echo "handler: ". $handler ."<br />";
					echo "<br />";
				}
				break;
			case "MySQL":
				$res = @mysql_fetch_object($handler);
				if ( mysql_error() ) {
					echo "An error occured while fetching an object (FETCH_OBJ)<br />";
					echo "mySQL-error: ". mysql_error() ."<br />";
					echo "handler: ". $handler ."<br />";
					echo "<br />";
				}
				break;
		}
		return $res;
	}
	
	function fetch_array($handler) {
		switch (DBT) {
			case "PostgreSQL":
				$res = pg_fetch_array($handler);
				if ( pg_last_error() ) {
					echo "An error occured while fetching an array (FETCH_ARR)<br />";
					echo "pgSQL-error: ". pg_last_error() ."<br />";
					echo "handler: ". $handler ."<br />";
					echo "object: ". $res ."<br />";
					echo "<br />";
				}
				break;
			case "MySQL":
				$res = mysql_fetch_array($handler);
				if ( mysql_error() ) {
					echo "An error occured while fetching an array (FETCH_ARR)<br />";
					echo "mySQL-error: ". mysql_error() ."<br />";
					echo "handler: ". $handler ."<br />";
					echo "object: ". $res ."<br />";
					echo "<br />";
				}
				break;
		}
		return $res;
	}

	
	function fetch_row($handler) {
		switch (DBT) {
			case "PostgreSQL":
				$res = pg_fetch_row($handler);
				if ( pg_last_error() ) {
					echo "An error occured while fetching a row (FETCH_ROW)<br />";
					echo "pgSQL-error: ". pg_last_error() ."<br />";
					echo "handler: ". $handler ."<br />";
					echo "object: ". $res ."<br />";
					echo "<br />";
				}
				break;
			case "MySQL":
				$res = mysql_fetch_row($handler);
				if ( mysql_error() ) {
					echo "An error occured while fetching a row (FETCH_ROW)<br />";
					echo "mySQL-error: ". mysql_error() ."<br />";
					echo "handler: ". $handler ."<br />";
					echo "object: ". $res ."<br />";
					echo "<br />";
				}
				break;
		}
		return $res;
	}
	
	function num_rows($resres) {
		switch (DBT) {
			case "PostgreSQL":
				$res = pg_num_rows($resres);
				break;
			case "MySQL":
				$res = mysql_num_rows($resres);
				break;
		}
		return $res;
	}
	
	function sql_error($handle) {
		switch (DBT) {
			case "PostgreSQL":
				$res = pg_last_error($handle);
				break;
			case "MySQL":
				$res = mysql_error($handle);
				break;
		}
		return $res;
	}
	
	function list_tables($handle, $dbname, $search="") {
		switch (DBT) {
			case "PostgreSQL":
				if ( $search != "" ) {
					$result = pg_query($handle, "SELECT * FROM pg_tables WHERE tablename LIKE '$search' AND schemaname='public'");
				} else {
					$result = pg_query($handle, "SELECT * FROM pg_tables WHERE schemaname='public'");
				}
				if ( pg_last_error() ) {
					return false;
				}
				$ergebnis = array();
				while ( $res = pg_fetch_array($result) ) {
					if ( pg_last_error() ) {
						return false;
					}
					array_push($ergebnis, $res);
				}
			break;
			case "MySQL":
				if ( $search != "" ) {
					$result = @mysql_query("SHOW TABLES FROM $dbname LIKE '$search'");
				} else {
					$result = @mysql_query("SHOW TABLES FROM $dbname");
				}
				if ( mysql_error() ) {
					return false;
				}
				$ergebnis = array();
				while($res = mysql_fetch_array($result)) {
					if ( mysql_error() ) {
						return false;
					}
					array_push($ergebnis, $res);
				}
			break;
		}
		return $ergebnis;
	}
	
	function has_content($handle, $dbname) {
		$ergebnis = false;
		switch (DBT) {
			case "MySQL":
				$result = @mysql_query("SELECT null FROM $dbname");
				if ( mysql_error() ) {
					die (mysql_error());
					return false;
				}
				if ( @mysql_num_rows($result) > 0 ) $ergebnis = true;
				if ( mysql_error() ) {
					return false;
				}
			break;
			case "PostgreSQL":
				$result = @pg_query($handle, "SELECT null FROM $dbname");
				if ( pg_last_error() ) {
					return false;
				}
				if ( @pg_num_rows($result) > 0 ) $ergebnis = true;
				if ( pg_last_error() ) {
					return false;
				}
			break;
		}
		return $ergebnis;
	}
	
	function unesc($x) {
    	if (get_magic_quotes_gpc())
		  return stripslashes($x);
		return $x;
	}

  function vcount() {
    $id=$_REQUEST['id'];
    include("data/includes/config.inc.php");
    $ddbh=connect("$dbhost", "$dbu", "$dbpw", "$dbn");
    $ergebnis = query($ddbh, "SELECT views FROM torrents WHERE ID='$id'");
	$row = fetch_object($ergebnis);
	$views=$row->views;
	$views++;
	query($ddbh, "UPDATE torrents SET views='$views' WHERE ID='$id'");
  }
  
  function whoisonline($akttime) {
  		$ret=array();
	    include("data/includes/config.inc.php");
		$ddbh=connect("$dbhost", "$dbu", "$dbpw", "$dbn");
		$ergebnis = query($ddbh, "SELECT name, time FROM users WHERE time!='0'");
		while($row = fetch_object($ergebnis)) {
				if($akttime-$row->time < 600) {
					array_push($ret, $row->name);
				}
		}
		return $ret ;
  }
  
  function dechash($enchash) {
			$ret=preg_replace_callback('/./s', "hex_esc", str_pad($enchash, 20));
			return $ret;
  }
  function bark($meldung) {
  		echo'<table width="600"  border="0" align="center" cellpadding="2" cellspacing="0" class="bark">';
		echo'<tr>';
		echo'<td align="center">';
		echo $meldung;
		echo'</td>';
		echo'</tr>';
		echo'</table>';
  }
  
  function checkstat($user, $status, $must, $message, $diff) {
	include("data/includes/config.inc.php");
	include("data/includes/lang_". $standard_lang .".inc.php");
	$res = true;
	if ( $noreg <= 1 ) {
		if (( $user=="none" ) OR ( $status<$must )) {
			bark("<h4>". htmlentities($message) .". <a href='index.php?page=login'>". htmlentities($lang_login) .".</a></h4>");
			$res = false;
		}
	}
	return $res;
  }
  
  function hex_esc($matches) {
	return sprintf("%02x", ord($matches[0]));
  }
  
   function url_validate( $link )
   {       
       $url_parts = @parse_url( $link );

       if ( empty( $url_parts["host"] ) ) return( false );

       if ( !empty( $url_parts["path"] ) )
       {
           $documentpath = $url_parts["path"];
       }
       else
       {
           $documentpath = "/";
       }

       if ( !empty( $url_parts["query"] ) )
       {
           $documentpath .= "?" . $url_parts["query"];
       }

       $host = $url_parts["host"];
       $port = $url_parts["port"];
       // Now (HTTP-)GET $documentpath at $host";

       if (empty( $port ) ) $port = "80";
       $socket = @fsockopen( $host, $port, $errno, $errstr, 10 );
       if (!$socket)
       {
           return(false);
       }
       else
       {
           fwrite ($socket, "HEAD ".$documentpath." HTTP/1.0\r\nHost: $host\r\n\r\n");
           $http_response = fgets( $socket, 22 );
          
           if ( ereg("200 OK", $http_response, $regs ) )
           {
               return(true);
               fclose( $socket );
           } else
           {
               return(false);
           }
       }
   }

function check_tracker($scrapeurl, $ihash) {
	global $yabtucurl;
	ini_set( 'user_agent', 'yaBTuc' );
/*	$uarr = parse_url ( $scrapeurl );
	$path = $uarr["path"];
	$host = $uarr["host"];
	$port = $uarr["port"];*/
	if ( !$uarr['port'] ) $port = 80;
	$fp = @gzopen($scrapeurl ."?info_hash=". urlencode(unesc($ihash)), "rb");
	if ( !$fp ) {
		if ( $scrapeurl{strlen($scrapeurl)} != "/" ) $scrapeurl .= "/";
		$scrapeurl .= "index.php";
		$fp = @gzopen($scrapeurl ."?info_hash=". urlencode(unesc($ihash)), "rb");
		if ( !$fp ) {
			if ( $scrapeurl{strlen($scrapeurl)} != "/" ) $scrapeurl .= "/";
			$scrapeurl = str_replace("index.php", "index.pl", $scrapeurl);
			$fp = @gzopen($scrapeurl ."?info_hash=". urlencode(unesc($ihash)), "rb");
			if ( !$fp ) {
				$scrapeurl = str_replace("index.pl", "index.py", $scrapeurl);
				$fp = @gzopen($scrapeurl ."?info_hash=". urlencode(unesc($ihash)), "rb");
			}
			if ( !$fp ) {
				$scrapeurl = str_replace("index.pl", "", $scrapeurl);
				$fp = @gzopen($scrapeurl ."?info_hash=". urlencode(unesc($ihash)), "rb");
			}
		}
	}
	$inhalt = "";
	if ( $fp ) {
	    while( !feof( $fp ) ) {
	        $inhalt .= @gzgets($fp, 128);
	    }
	    @gzclose ( $fp );
		$decoded = bdec($inhalt);

		if(isset($decoded)) {
			if(isset($decoded['value']['files']['value'][unesc($ihash)]['value']['complete']['value'])) {
				$ret=array("d"=>$decoded['value']['files']['value'][unesc($ihash)]['value']['downloaded']['value'], "i"=>$ret=$decoded['value']['files']['value'][$ihash]['value']['incomplete']['value'], "c"=>$ret=$decoded['value']['files']['value'][$ihash]['value']['complete']['value']);
		    	return $ret;
		  	} else {
		    	$ret=array("d"=>"purged", "i"=>"purged", "c"=>"purged");
		    	return $ret;
		  	}
		} else {
			$ret=array("d"=>"error", "i"=>"error", "c"=>"error");
			return $ret;
		}
	} else {
		$ret=array("d"=>"n/a", "i"=>"n/a", "c"=>"n/a");
		return $ret;
	}
	return $ret;
}

function dict_check($d, $s) {
	if ($d["type"] != "dictionary")
		bark("not a dictionary");
	$a = explode(":", $s);
	$dd = $d["value"];
	$ret = array();
	foreach ($a as $k) {
		unset($t);
		if (preg_match('/^(.*)\((.*)\)$/', $k, $m)) {
			$k = $m[1];
			$t = $m[2];
		}
/*		if (!isset($dd[$k])) {
			echo"dictionary is missing key(s)";
			die();
		}
*/
		if (isset($t)) {
/*			if ($dd[$k]["type"] != $t) {
				echo"invalid entry in dictionary";
				die();
			}
*/
			$ret[] = $dd[$k]["value"];
		}
		else {
			$ret[] = $dd[$k];
		}
	}
	return $ret;
}

function clearify($in) {
	switch (DBT) {
		case "PostgreSQL":
			$res = pg_escape_string(strip_tags($in));
			break;
		case "MySQL":
			$res = mysql_escape_string(strip_tags($in));
			break;
	}
	return $res;
}

function declearify($in) {
	$res = strip_tags($in);
	return $res;
}

function addtorrent($dbh, $typ, $name, $bewertung, $aktdatetime, $totallen, $uploader, $dname, $beschreibung, $ann, $eschash, $dld, $incomp, $comp, $purename, $imdblink, $anzfiles, $register, $stamp, $uid) {
	switch (DBT) {
		case "PostgreSQL":
			query($dbh, "INSERT INTO torrents (id, typ, name, wertung, anzwert, hinzugefuegt, groesse, uploader, dlname, beschreibung, views, hits, announce, hash, tr_downloaded, tr_incomplete, tr_complete, purename, imdblink, anzfiles, offsince, register, lastupdate, added, voted) VALUES (nextval('public.torrents_id_seq'::text), '$typ', '$name', '$bewertung', '1', '$aktdatetime', '$totallen', '$uploader', '$dname', '$beschreibung', '0', '0', '$ann', '$eschash', '$dld', '$incomp', '$comp', '$purename', '$imdblink', '$anzfiles', '0', '$register', '$stamp', '$stamp', '$uid')");
			break;
		case "MySQL":
			query($dbh, "INSERT INTO torrents (id, typ, name, wertung, anzwert, hinzugefuegt, groesse, uploader, dlname, beschreibung, views, hits, announce, hash, tr_downloaded, tr_incomplete, tr_complete, purename, imdblink, anzfiles, offsince, register, lastupdate, added, voted) VALUES ('', '$typ', '$name', '$bewertung', '1', '$aktdatetime', '$totallen', '$uploader', '$dname', '$beschreibung', '0', '0', '$ann', '$eschash', '$dld', '$incomp', '$comp', '$purename', '$imdblink', '$anzfiles', '0', '$register', '$stamp', '$stamp', '$uid')");
			break;
	}
	return;
}

function enchash($in) {
	switch (DBT) {
		case "PostgreSQL":
			$res = pg_escape_string($in);
			break;
		case "MySQL":
			$res = mysql_escape_string($in);
			break;
	}
	return $res;
}

function dict_get($d, $k, $t) {
	if ($d["type"] != "dictionary")
		bark("not a dictionary");
	$dd = $d["value"];
	if (!isset($dd[$k]))
		return;
	$v = $dd[$k];
	if ($v["type"] != $t)
		bark("invalid dictionary entry type");
	return $v["value"];
}

function get_stats($sessid) {
  include("data/includes/config.inc.php");
  $dbh = connect("$dbhost", "$dbu", "$dbpw", "$dbn");
  $ergebnis = query($dbh, "SELECT id, name, status, show, lang FROM users WHERE sessid = '$sessid'", false);
  if ( $ergebnis ) $row = fetch_object($ergebnis);
  $status = 0;
  if (( $row->name != "" ) AND ( $row->name != "guest" ) AND ( $acttime-$row->time < 600 )) {
      $user="$row->name";
	  $status="$row->status";
	  $show = "$row->show";
	  $lang = "$row->lang";
	  $uid = "$row->id";
	  $re=query($dbh, "SELECT name FROM ranks WHERE punkte = '$status'");
	  $rrow = fetch_object($re);
	  $rank = $rrow->name;
  } elseif ( isset($_COOKIE['yabtuc']) ) {
		list($uname, $pw) = split('\[\!\!\]', $_COOKIE['yabtuc']);
		switch (DBT) {
			case "MySQL":
				$li = query($dbh, "SELECT `id`, `name`, `status`, `show`, `password`, `lang` FROM `users` WHERE `name` = '$uname'");
			break;
			case "PostgreSQL":
				$li = query($dbh, "SELECT id, name, status, show, password, lang FROM users WHERE name = '$uname'");
			break;
		}
		$lirow = fetch_object($li);
		if ( "$lirow->password" == "$pw" ) {
	      $user="$lirow->name";
		  $status="$lirow->status";
		  $show = "$lirow->show";
		  $lang = "$lirow->lang";
		  $uid = "$lirow->id";
	  	  $re=query($dbh, "SELECT name FROM ranks WHERE punkte = '$status'");
		  $rrow = fetch_object($re);
		  $rank = $rrow->name;
		  query($dbh, "UPDATE users SET sessid='$sessid', time='$acttime', last='$aktdatetime', ipaddr='$ipaddr' WHERE name='$uname'");
//* LOGGING *//
			if ( $log["loginok"] == "1" ) {
				$lf = fopen ($logfile, 'a');
				fwrite($lf, $ipaddr .' - '. $user .' ['. $logdate .'] "LOGIN '. $user .'"' . "\r\n");
				fclose($lf);
			}
		}
  } else {
	$status = 0;
	$rank = "unreg";
	$lang = $standard_lang;
	$show = $stdlimit;
	$uid = 0;
  	if ( $noreg == 1 ) {
		$user="guest";
		query($dbh, "UPDATE users SET sessid='$sessid', time='$acttime', last='$aktdatetime', ipaddr='$ipaddr' WHERE name='guest'");
//* LOGGING *//
		if ( $log["guestlog"] == "1" ) {
			$lf = fopen ($logfile, 'a');
			fwrite($lf, $ipaddr .' - '. $user .' ['. $logdate .'] "LOGIN '. $user .'"' . "\r\n");
			fclose($lf);
		}
	} else {
		$user="none";
	}
  }
  $res = array($uid, $user, $status, $rank, $show, $lang, $acttime);

  return $res;
}

	function createtags($name, $inhalt) {
		$et = split(" ", $name);
		$endtag = $et[0];
		$res = '<'. $name .'>'. $inhalt .'</'. $endtag .'>';
		return $res;
	}
	
	function smiliefy($input) {

		global $smilies;
		if ( !$smilies ) {
			include("data/includes/config.inc.php");
			$dbh=connect("$dbhost", "$dbu", "$dbpw", "$dbn");
			$smilies = array();
			$smile=query($dbh, "SELECT bbcode, img FROM smilies");
			while ( $srow = fetch_object($smile) )  {
				$smilie = array ( "bbcode" => $srow->bbcode, "image" => $srow->img );
				array_push( $smilies, $smilie );
			}
		}
		
		$res = $input;
		
		foreach ( $smilies as $sm ) {
			$smimg = $sm["image"];
			$smbb = $sm["bbcode"];
			$res = str_replace($sm['bbcode'], "<img src='data/pix/smilies/$smimg' alt='$smbb'>", $res);
		}
		
		return $res;
	}
	
	function bbdecode($input) {
		$res = $input;
		$res = str_replace("[b]", "<strong>", $res);
		$res = str_replace("[/b]", "</strong>", $res);
		$res = str_replace("[i]", "<em>", $res);
		$res = str_replace("[/i]", "</em>", $res);
		$res = str_replace("[u]", "<u>", $res);
		$res = str_replace("[/u]", "</u>", $res);

		$res = str_replace("[left]", "<div align='left'>", $res);
		$res = str_replace("[/left]", "</div>", $res);
		$res = str_replace("[center]", "<div align='center'>", $res);
		$res = str_replace("[/center]", "</div>", $res);
		$res = str_replace("[right]", "<div align='right'>", $res);
		$res = str_replace("[/right]", "</div>", $res);

		$res = str_replace("[B]", "<strong>", $res);
		$res = str_replace("[/B]", "</strong>", $res);
		$res = str_replace("[I]", "<em>", $res);
		$res = str_replace("[/I]", "</em>", $res);
		$res = str_replace("[U]", "<u>", $res);
		$res = str_replace("[/U]", "</u>", $res);

		$res = str_replace("[LEFT]", "<div align='left'>", $res);
		$res = str_replace("[/LEFT]", "</div>", $res);
		$res = str_replace("[CENTER]", "<div align='center'>", $res);
		$res = str_replace("[/CENTER]", "</div>", $res);
		$res = str_replace("[RIGHT]", "<div align='right'>", $res);
		$res = str_replace("[/RIGHT]", "</div>", $res);

		$res = preg_replace("/\[font=(.*?)\](.*?)\[\/font\]/si", "<font face='$1'>$2</font>", $res);
		$res = preg_replace("/\[size=(.*?)\](.*?)\[\/size\]/si", "<font size='$1'>$2</font>", $res);
		$res = preg_replace("/\[color=(.*?)\](.*?)\[\/color\]/si", "<font color='$1'>$2</font>", $res);
		$res = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/si", "<a href='$1' target='_blank'>$2</a>", $res);
		$res = preg_replace("/\[email=(.*?)\](.*?)\[\/email\]/si", "<a href='mailto:$1'>$2</a>", $res);
		$res = preg_replace("/\[img\](.*?)\[\/img\]/i", "<img src='$1' alt='$1' />", $res);

		return smiliefy($res);
	}

	function rssdecode($rf) {
/*	Altes RSS-File auslesen
*/
			$fp = @fopen("$rf","rb");
			if ( $fp ) {
				$inhalt = "";
				while ( !feof($fp) ) {
					$inhalt.= @fread($fp,1024);
				}
			}
			@fclose($fp);

/*	RSS-Feed-Array zusammenstellen
*/

			preg_match("/(<\?xml.*>)/i",$inhalt, $xmlhead);
			preg_match("/(<rss.*?>)/i",$inhalt, $rsshead);

			preg_match("/<title>([^<]+)<\/title>/i",$inhalt, $title);
			preg_match("/<link>([^<]+)<\/link>/i",$inhalt, $link);
			preg_match("/<description>([^<]+)<\/description>/i",$inhalt, $description);
			
			$header = array( "title" => $title[1], "link" => $link[1], "description" => $description[1] );
			
			preg_match_all("/<item.*?>(.*?)<\/item>/is", $inhalt, $di);

			$items = array();
			for ( $i = 0; $i < count($di[1]); $i++ ) {
				preg_match("/<title>([^<]+)<\/title>/i",$di[1][$i], $title);
				preg_match("/<link>([^<]+)<\/link>/i",$di[1][$i], $ilink);
				preg_match("/<description>([^<]+)<\/description>/i",$di[1][$i], $description);
				preg_match("/<guid.*?>([^<]+)<\/guid.*?>/i",$di[1][$i], $guid);
				preg_match("/<pubdate>([^<]+)<\/pubdate>/i",$di[1][$i], $pubdate);
				$item = array ( "title" => "$title[1]", "link" => "$ilink[1]", "description" => "$description[1]", "guid" => "$guid[1]", "pubdate" => "$pubdate[1]" );
				array_push($items, $item);
			}
			
			$feed = array( "xmlhead" => "$xmlhead[0]", "rsshead" => "$rsshead[0]", "head" => $header, "items" => $items);
			return $feed;
	}
	
	function natsort2d(&$aryInput) {
		$aryTemp = $aryOut = array();
		foreach ($aryInput as $key=>$value) {
			reset($value);
			$aryTemp[$key]=current($value);
		}
		natsort($aryTemp);
			foreach ($aryTemp as $key=>$value) {
			$aryOut[] = $aryInput[$key];
		}
		return $aryInput = $aryOut;
	}
	
	function convsize( $size ) {
		$state = 0;
		if ( $size / 1024 >= 1.2 ) {
			// byte -> kb
			$size = round( $size / 1024 );
			$state = 1;
		}
		if ( $size / 1024 >= 1.2 ) {
			// kb -> mb
			$size = round( $size / 1024, 1 );
			$state = 2;
		}
		if ( $size / 1024 >= 1.2 ) {
			// mb -> gb
			$size = round( $size / 1024, 2 );
			$state = 3;
		}
		if ( $state == 0 ) $size = $size ." byte";
		if ( $state == 1 ) $size = $size ." KB";
		if ( $state == 2 ) $size = $size ." MB";
		if ( $state == 3 ) $size = $size ." GB";
		
		return $size;
	}
	
	function ambmail($to, $subject, $headers, $message) {
		global $yabtucemail;
		 // Could get this from the php ini?
		 $from = $yabtucemail;
		 list($me, $mydomain) = split("@", $from);
		
		 // Now look up the mail exchangers for the recipient
		 list($user,$domain) = split("@",$to,2);
		 if(getmxrr($domain,$mx,$weight) == 0)  return FALSE;
		
		 // Try them in order of lowest weight first
		 array_multisort($mx,$weight);
		 $success=0;
		
		 foreach($mx as $host) {
			// Open an SMTP connection
			$connection = @fsockopen ($host, 25, $errno, $errstr, 1);
			if (!$connection)
			continue;
			$res=fgets($connection,256);
			if(substr($res,0,3) != "220") break;
			
			// Introduce ourselves
			fputs($connection, "HELO $mydomain\n");
			$res=fgets($connection,256);
			if(substr($res,0,3) != "250") break;
			
			// Envelope from
			fputs($connection, "MAIL FROM: <". $from .">\n");
			$res=fgets($connection,256);
			if(substr($res,0,3) != "250") break;
			
			// Envelope to
			fputs($connection, "RCPT TO: <". $to .">\n");
			$res=fgets($connection,256);
			if(substr($res,0,3) != "250") break;
			
			// The message
			fputs($connection, "DATA\n");
			$res=fgets($connection,256);
			if(substr($res,0,3) != "354") break;
			
			// Send To:, From:, Subject:, other headers, blank line, message, and finish
			// with a period on its own line.
			fputs($connection, "To: $to\nFrom: $from\nSubject: $subject\n$headers\n\n$message\r\n.\r\n");
			$res=fgets($connection,256);
			if(substr($res,0,3) != "250") break;
			
			// Say bye bye
			fputs($connection,"QUIT\n");
			$res=fgets($connection,256);
			if(substr($res,0,3) != "221") break;
			
			// It worked! So break out of the loop which tries all the mail exchangers.
			$success=1;
			break;
		 }
		 // Debug for if we fall over - uncomment as desired
		 // print $success?"Mail sent":"Failure: $res\n";
		 if($connection) {
			if($success==0) fputs($connection, "QUIT\n");
			fclose ($connection);
		 }
		 return $success?TRUE:FALSE;
	} 
	
	function output ( $output ) {
		$output = str_replace("&", "&amp;", $output);
		$output = str_replace("", "&uuml;", $output);
		$output = str_replace("", "&Uuml;", $output);
		$output = str_replace("", "&ouml;", $output);
		$output = str_replace("", "&Ouml;", $output);
		$output = str_replace("", "&auml;", $output);
		$output = str_replace("", "&Auml;", $output);
		$output = str_replace("", "&szlig;", $output);
		$output = str_replace(">", "&gt;", $output);
		$output = str_replace("<", "&lt;", $output);
		$output = str_replace("[br]", "<br />", $output);
		$output = preg_replace("/\[b\](.*?)\[\/b\]/", "<span class=\"fat\">$1</span>", $output);
		$output = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/", "<a href=\"$1\" target=\"_blank\">$2</a>", $output);
		$output = preg_replace("/\[inturl=(.*?)\](.*?)\[\/inturl\]/", "<a href=\"$1\">$2</a>", $output);
		echo $output;
	}
	
	function mkid ( $input ) {
		$arr = split( " ", $input );
		$res = "";
		foreach ( $arr as $an ) {
			$res .= strtolower($an[0]);
		}
		return $res;
	}
	
	function inlay_start( $width = 500 ) {
?>
		<table width="<?php echo $width; ?>" border="0" align="center" cellpadding="0" cellspacing="0"> 
			<tr>
				<td background="data/pix/bg/em_ul.jpg" height="15" width="60">&nbsp;</td>
				<td background="data/pix/bg/em_um.jpg" width="370">&nbsp;</td>
				<td background="data/pix/bg/em_ur.jpg" width="70">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="3" class="back2" align="center">
					<br />
<?php
	}
	function inlay_stop() {
?>
					<br />
				</td>
			</tr>
			<tr>
				<td background="data/pix/bg/em_ll.jpg" height="21" width="60">&nbsp;</td>
				<td background="data/pix/bg/em_lm.jpg">&nbsp;</td>
				<td background="data/pix/bg/em_lr.jpg" width="70">&nbsp;</td>
			</tr>
		</table>
<?php
	}
	
?>