#
# TOC entry 5 (OID 28955)
# Name: autodl; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE autodl (
    id serial NOT NULL,
    serviceurl text NOT NULL,
    name text NOT NULL,
    searchstr text NOT NULL,
    typ smallint DEFAULT (0)::smallint NOT NULL,
    descr text NOT NULL,
    uploader text NOT NULL
);


#
# TOC entry 6 (OID 28955)
# Name: autodl; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE autodl FROM PUBLIC;


#
# TOC entry 7 (OID 28964)
# Name: avatars; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE avatars (
    id serial NOT NULL,
    name text NOT NULL,
    image text NOT NULL
);


#
# TOC entry 8 (OID 28964)
# Name: avatars; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE avatars FROM PUBLIC;


#
# TOC entry 9 (OID 28972)
# Name: comments; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE comments (
    id serial NOT NULL,
    tid integer DEFAULT 0 NOT NULL,
    username text NOT NULL,
    datum character varying(20) NOT NULL,
    kommentar text NOT NULL
);


#
# TOC entry 10 (OID 28972)
# Name: comments; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE comments FROM PUBLIC;


#
# TOC entry 11 (OID 28981)
# Name: messages; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE messages (
    id serial NOT NULL,
    mfrom text NOT NULL,
    mto text NOT NULL,
    fup integer DEFAULT 0 NOT NULL,
    datum character varying(20) NOT NULL,
    betreff text NOT NULL,
    inhalt text NOT NULL,
    gelesen smallint DEFAULT (0)::smallint NOT NULL
);


#
# TOC entry 12 (OID 28981)
# Name: messages; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE messages FROM PUBLIC;


#
# TOC entry 13 (OID 28991)
# Name: news; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE news (
    id serial NOT NULL,
    datum character varying(20) NOT NULL,
    inhalt text NOT NULL
);


#
# TOC entry 14 (OID 28991)
# Name: news; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE news FROM PUBLIC;


#
# TOC entry 15 (OID 28999)
# Name: ranks; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE ranks (
    id serial NOT NULL,
    name text NOT NULL,
    punkte smallint DEFAULT (0)::smallint NOT NULL
);


#
# TOC entry 16 (OID 28999)
# Name: ranks; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE ranks FROM PUBLIC;


#
# TOC entry 17 (OID 29008)
# Name: torrents; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE torrents (
    id serial NOT NULL,
    typ smallint DEFAULT (0)::smallint NOT NULL,
    name text NOT NULL,
    wertung smallint DEFAULT (0)::smallint NOT NULL,
    anzwert integer DEFAULT 0 NOT NULL,
    hinzugefuegt character varying(20) NOT NULL,
    groesse integer DEFAULT 0 NOT NULL,
    uploader text NOT NULL,
    dlname text NOT NULL,
    beschreibung text NOT NULL,
    views integer DEFAULT 0 NOT NULL,
    hits integer DEFAULT 0 NOT NULL,
    announce text NOT NULL,
    hash text NOT NULL,
    tr_downloaded text NOT NULL,
    tr_incomplete text NOT NULL,
    tr_complete text NOT NULL,
    purename text NOT NULL,
    imdblink character varying(128) NOT NULL,
    anzfiles integer NOT NULL,
    offsince smallint NOT NULL,
    register smallint NOT NULL,
    lastupdate character varying(64) NOT NULL,
    added character varying(64) NOT NULL,
    voted text NOT NULL
);


#
# TOC entry 18 (OID 29008)
# Name: torrents; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE torrents FROM PUBLIC;


#
# TOC entry 19 (OID 29022)
# Name: users; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE users (
    id serial NOT NULL,
    name text NOT NULL,
    "password" text NOT NULL,
    sessid text NOT NULL,
    "time" text NOT NULL,
    whoisit text NOT NULL,
    status smallint DEFAULT (0)::smallint NOT NULL,
    registered character varying(20) NOT NULL,
    "last" character varying(20) NOT NULL,
    avatar smallint DEFAULT (0)::smallint NOT NULL,
    descr text NOT NULL,
    dld integer DEFAULT 0 NOT NULL,
    upd integer DEFAULT 0 NOT NULL,
    "show" smallint NOT NULL,
    ipaddr text NOT NULL,
    emailverified smallint NOT NULL,
    email character varying(255) NOT NULL,
    lang character varying(3) NOT NULL,
    tr_up double precision NOT NULL,
    tr_down double precision NOT NULL
);


#
# TOC entry 20 (OID 29022)
# Name: users; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE users FROM PUBLIC;


#
# TOC entry 21 (OID 29034)
# Name: genres; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE genres (
    id serial NOT NULL,
    name text NOT NULL,
    bild text NOT NULL
);


#
# TOC entry 22 (OID 29042)
# Name: shoutbox; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE shoutbox (
    id serial NOT NULL,
    username character varying(64) NOT NULL,
    datum character varying(20) NOT NULL,
    inhalt text NOT NULL
);


#
# TOC entry 23 (OID 29042)
# Name: shoutbox; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE shoutbox FROM PUBLIC;


#
# TOC entry 24 (OID 29050)
# Name: smilies; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE smilies (
    id serial NOT NULL,
    bbcode character varying(8) NOT NULL,
    img character varying(32) NOT NULL,
    name character varying(128) NOT NULL
);


#
# TOC entry 25 (OID 29050)
# Name: smilies; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE smilies FROM PUBLIC;

#
# TOC entry 29 (OID 29422)
# Name: tracker_content; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE tracker_content (
    id serial NOT NULL,
    hash character varying(50) DEFAULT ''::character varying NOT NULL,
    stamp double precision DEFAULT 0::double precision NOT NULL,
    seeder bigint DEFAULT 0::bigint NOT NULL,
    leecher bigint DEFAULT 0::bigint NOT NULL,
    complete double precision DEFAULT 0::double precision NOT NULL,
    peer_pid character varying(90) DEFAULT ''::character varying NOT NULL,
    peer_ip character varying(50) DEFAULT ''::character varying NOT NULL,
    peer_port integer DEFAULT 0 NOT NULL,
    peer_uploaded double precision DEFAULT 0::double precision NOT NULL,
    peer_downloaded double precision DEFAULT 0::double precision NOT NULL,
    peer_left double precision DEFAULT 0::double precision NOT NULL,
    peer_stamp double precision DEFAULT 0::double precision NOT NULL,
    peer_status character varying(8) DEFAULT 'leeching'::character varying NOT NULL,
    peer_completed character varying(3) DEFAULT 'yes'::character varying NOT NULL,
    CONSTRAINT tracker_content_peer_completed CHECK ((((peer_completed)::text = 'yes'::text) OR ((peer_completed)::text = 'no'::text))),
    CONSTRAINT tracker_content_peer_status CHECK ((((peer_status)::text = 'leeching'::text) OR ((peer_status)::text = 'seeding'::text)))
);


#
# TOC entry 30 (OID 29422)
# Name: tracker_content; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE tracker_content FROM PUBLIC;

#
# TOC entry 3 (OID 29462)
# Name: tracker_blacklist; Type: TABLE; Schema: public; Owner: bttest
#

CREATE TABLE tracker_blacklist (
    id serial NOT NULL,
    ip character varying(64) NOT NULL
);

#
# TOC entry 3 (OID 29462)
# Name: tracker_content; Type: ACL; Schema: public; Owner: bttest
#

REVOKE ALL ON TABLE tracker_blacklist FROM PUBLIC;

CREATE TABLE delays (
  id serial NOT NULL,
  ratio decimal default '0.00' NOT NULL,
  up double precision default '0' NOT NULL,
  delay smallint default '0' NOT NULL
);

REVOKE ALL ON TABLE delays FROM PUBLIC;
#
# TOC entry 31 (OID 29066)
# Name: autodl_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY autodl
    ADD CONSTRAINT autodl_pkey PRIMARY KEY (id);


SELECT pg_catalog.setval('autodl_id_seq', 1, true);

#
# TOC entry 32 (OID 29068)
# Name: avatars_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY avatars
    ADD CONSTRAINT avatars_pkey PRIMARY KEY (id);


SELECT pg_catalog.setval('avatars_id_seq', 1, true);

#
# TOC entry 33 (OID 29070)
# Name: comments_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY comments
    ADD CONSTRAINT comments_pkey PRIMARY KEY (id);


SELECT pg_catalog.setval('comments_id_seq', 1, true);

#
# TOC entry 21 (OID 29034)
# Name: genres_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY genres
    ADD CONSTRAINT genres_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('genres_id_seq', 1, true);

#
# TOC entry 34 (OID 29072)
# Name: messages_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY messages
    ADD CONSTRAINT messages_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('messages_id_seq', 1, true);

#
# TOC entry 35 (OID 29074)
# Name: news_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY news
    ADD CONSTRAINT news_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('news_id_seq', 1, true);

#
# TOC entry 36 (OID 29076)
# Name: ranks_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY ranks
    ADD CONSTRAINT ranks_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('ranks_id_seq', 1, true);

#
# TOC entry 37 (OID 29078)
# Name: torrents_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY torrents
    ADD CONSTRAINT torrents_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('torrents_id_seq', 1, true);

#
# TOC entry 38 (OID 29080)
# Name: users_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY users
    ADD CONSTRAINT users_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('users_id_seq', 1, true);

#
# TOC entry 39 (OID 29082)
# Name: shoutbox_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY shoutbox
    ADD CONSTRAINT shoutbox_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('shoutbox_id_seq', 1, true);

#
# TOC entry 40 (OID 29084)
# Name: smilies_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY smilies
    ADD CONSTRAINT smilies_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('smilies_id_seq', 1, true);

#
# TOC entry 42 (OID 29441)
# Name: tracker_content_pkey; Type: CONSTRAINT; Schema: public; Owner: bttest
#

ALTER TABLE ONLY tracker_content
    ADD CONSTRAINT tracker_content_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('tracker_content_id_seq', 1, true);

#
# TOC entry 3 (OID 29462)
# Name: tracker_blacklist; Type: TABLE; Schema: public; Owner: bttest
#

ALTER TABLE ONLY tracker_blacklist
    ADD CONSTRAINT tracker_blacklist_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('tracker_blacklist_id_seq', 1, true);

ALTER TABLE ONLY delays
    ADD CONSTRAINT delays_pkey PRIMARY KEY (id);

SELECT pg_catalog.setval('delays_id_seq', 1, true);
